KSocks Class Reference

`#include <ksocks.h>`

## Public Member Functions

void | disableSocks ()
void | enableSocks ()
bool | usingSocks ()
bool | hasSocks ()
bool | hasWorkingAsyncConnect ()
int | connect (int sockfd, const sockaddr *serv_addr, ksocklen_t addrlen)
signed long int | read (int fd, void *buf, unsigned long int count)
signed long int | write (int fd, const void *buf, unsigned long int count)
int | recvfrom (int s, void *buf, unsigned long int len, int flags, sockaddr *from, ksocklen_t *fromlen)
int | sendto (int s, const void *msg, unsigned long int len, int flags, const sockaddr *to, ksocklen_t tolen)
int | recv (int s, void *buf, unsigned long int len, int flags)
int | send (int s, const void *msg, unsigned long int len, int flags)
int | getsockname (int s, sockaddr *name, ksocklen_t *namelen)
int | getpeername (int s, sockaddr *name, ksocklen_t *namelen)
int | accept (int s, sockaddr *addr, ksocklen_t *addrlen)
int | select (int n, fd_set *readfds, fd_set *writefds, fd_set *exceptfds, struct timeval *timeout)
int | listen (int s, int backlog)
int | bind (int sockfd, sockaddr *my_addr, ksocklen_t addrlen)
int | bind (int sockfd, const sockaddr *my_addr, ksocklen_t addrlen)
void | die ()

## Static Public Member Functions

static KSocks * | self ()
static bool | activated ()
static void | disable ()
static void | setConfig (KConfigBase *config)

## Friends

class | KStaticDeleter< KSocks >

## Detailed Description

This class provides you with an interface to a SOCKS Proxy server.

A SOCKS server is able to provide full internet access behind a firewall. KSocks is a singleton; there can only be one instance at any given time. To obtain a reference to that instance, use self().

Access to a SOCKS Proxy.

Definition at line 48 of file ksocks.h.

## Member Function Documentation

int KSocks::accept | ( | int | s,
|  | sockaddr * | addr,
|  | ksocklen_t * | addrlen
| ) |  |

This is the re-implementation of libc's function of the same name.

Read the appropriate man page.

Definition at line 560 of file ksocks.cpp.

bool KSocks::activated | ( |  | ) |

static

Checks whether KSocks has been started (ie someone called self())

Returns
  true if activated

Definition at line 239 of file ksocks.cpp.

int KSocks::bind | ( | int | sockfd,
|  | sockaddr * | my_addr,
|  | ksocklen_t | addrlen
| ) |  |

This is the re-implementation of libc's function of the same name.

Read the appropriate man page.

Definition at line 593 of file ksocks.cpp.

int KSocks::connect | ( | int | sockfd,
|  | const sockaddr * | serv_addr,
|  | ksocklen_t | addrlen
| ) |  |

This is the re-implementation of libc's function of the same name.

Read the appropriate man page.

Definition at line 479 of file ksocks.cpp.

void KSocks::die | ( |  | ) |

If you're using this, you're probably doing something wrong.

Please don't use it.

Definition at line 425 of file ksocks.cpp.

void KSocks::disable | ( |  | ) |

static

Set this before the first call to KSocks::self() and it will fail to initialize SOCKS.

Definition at line 206 of file ksocks.cpp.

void KSocks::disableSocks | ( |  | ) |

Disable the use of SOCKS immediately.

Definition at line 458 of file ksocks.cpp.

void KSocks::enableSocks | ( |  | ) |

Enable the use of SOCKS immediately if hasSocks() is true.

Definition at line 463 of file ksocks.cpp.

int KSocks::getpeername | ( | int | s,
|  | sockaddr * | name,
|  | ksocklen_t * | namelen
| ) |  |

This is the re-implementation of libc's function of the same name.

Read the appropriate man page.

Definition at line 548 of file ksocks.cpp.

int KSocks::getsockname | ( | int | s,
|  | sockaddr * | name,
|  | ksocklen_t * | namelen
| ) |  |

This is the re-implementation of libc's function of the same name.

Read the appropriate man page.

Definition at line 536 of file ksocks.cpp.

bool KSocks::hasSocks | ( |  | ) |

Checks whether SOCKS is available for use.

Returns
  true if SOCKS is available for use.

Definition at line 453 of file ksocks.cpp.

bool KSocks::hasWorkingAsyncConnect | ( |  | ) |

Returns whether asynchronous connects work with the selected SOCKS impementation.

Definition at line 468 of file ksocks.cpp.

int KSocks::listen | ( | int | s,
|  | int | backlog
| ) |  |

This is the re-implementation of libc's function of the same name.

Read the appropriate man page.

Definition at line 580 of file ksocks.cpp.

signed long int KSocks::read | ( | int | fd,
|  | void * | buf,
|  | unsigned long int | count
| ) |  |

This is the re-implementation of libc's function of the same name.

Read the appropriate man page.

Definition at line 487 of file ksocks.cpp.

int KSocks::recv | ( | int | s,
|  | void * | buf,
|  | unsigned long int | len,
|  | int | flags
| ) |  |

This is the re-implementation of libc's function of the same name.

Read the appropriate man page.

Definition at line 522 of file ksocks.cpp.

int KSocks::recvfrom | ( | int | s,
|  | void * | buf,
|  | unsigned long int | len,
|  | int | flags,
|  | sockaddr * | from,
|  | ksocklen_t * | fromlen
| ) |  |

This is the re-implementation of libc's function of the same name.

Read the appropriate man page.

Definition at line 501 of file ksocks.cpp.

int KSocks::select | ( | int | n,
|  | fd_set * | readfds,
|  | fd_set * | writefds,
|  | fd_set * | exceptfds,
|  | struct timeval * | timeout
| ) |  |

This is the re-implementation of libc's function of the same name.

Read the appropriate man page.

Definition at line 572 of file ksocks.cpp.

KSocks * KSocks::self | ( |  | ) |

static

Return an instance of class KSocks *.

You cannot delete this object. It is a singleton class.

Returns
  the KSock instance

Definition at line 212 of file ksocks.cpp.

int KSocks::send | ( | int | s,
|  | const void * | msg,
|  | unsigned long int | len,
|  | int | flags
| ) |  |

This is the re-implementation of libc's function of the same name.

Read the appropriate man page.

Definition at line 529 of file ksocks.cpp.

int KSocks::sendto | ( | int | s,
|  | const void * | msg,
|  | unsigned long int | len,
|  | int | flags,
|  | const sockaddr * | to,
|  | ksocklen_t | tolen
| ) |  |

This is the re-implementation of libc's function of the same name.

Read the appropriate man page.

Definition at line 514 of file ksocks.cpp.

void KSocks::setConfig | ( | KConfigBase * | config | ) |

static

Set this before the first call to KSocks::self() and it will use `config` to read its configuration from.

Definition at line 226 of file ksocks.cpp.

bool KSocks::usingSocks | ( |  | ) |

Checks whether SOCKS is currently being used.

Returns
  true if SOCKS is currently being used.

Definition at line 448 of file ksocks.cpp.

signed long int KSocks::write | ( | int | fd,
|  | const void * | buf,
|  | unsigned long int | count
| ) |  |

This is the re-implementation of libc's function of the same name.

Read the appropriate man page.

Definition at line 494 of file ksocks.cpp.

The documentation for this class was generated from the following files:

- ksocks.h
- ksocks.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys